package org.ow2.choreos.chordevelopment.analysis.depanalyzer.analysis.core;

import java.util.Collection;

import org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.algorithms.GraphAnalyzer;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.entity.SimpleEdge;

import edu.uci.ics.jung.graph.DirectedGraph;


public class RippleEffectCalculator<V,E> {

	/**
	 * Calculates ripple effect based on the transitive closure of the graph
	 * @param dependencyGraph
	 * @param vertexToAnalyze
	 * @return
	 */
	public Collection<V> calculate(DirectedGraph<V,E> dependencyGraph, 
			V vertexToAnalyze){
		
		GraphAnalyzer<V, E> graphAnalyzer = new GraphAnalyzer<V,E>();
		
		DirectedGraph<V, SimpleEdge> transitiveClosure = 
				graphAnalyzer.getTransitiveClosureFrom(dependencyGraph);
		
		Collection<V> impacted = transitiveClosure.getPredecessors(
				vertexToAnalyze);
		
		return impacted;
	}
	
}