package org.ow2.choreos.chordevelopment.analysis.depanalyzer.sia.graph.algorithms;

import static org.junit.Assert.assertEquals;

import org.junit.Test;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.algorithms.GraphAnalyzer;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.algorithms.stability.StabilityAnalysis;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.entity.Edge;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.entity.Vertex;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.tests.sia.util.GraphFactory;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.tests.sia.util.GraphFactory.TestGraph;

import edu.uci.ics.jung.graph.DirectedGraph;

public class StabilityTest {

	private final double EPSILON = 0.0001;
	
	//@Test
	public void shouldCalculateSimpleOverallStability() {
		
		GraphFactory factory = new GraphFactory();
		DirectedGraph<Vertex, Edge> graph = factory.getGraph(TestGraph.SIMPLE);
		
		StabilityAnalysis expectedStability = factory.getStabilityAnalysis(TestGraph.SIMPLE);
		
		GraphAnalyzer depAnalyzer = new GraphAnalyzer(graph);
		StabilityAnalysis actualStability = depAnalyzer.calculateStabilityAnalysis();
		
		assertEquals(expectedStability.getOverallStability(),
				actualStability.getOverallStability(), EPSILON);
	}

	//@Test
	public void shouldCalculateComplexOverallStability() {
			
		GraphFactory factory = new GraphFactory();
		DirectedGraph<Vertex, Edge> graph = factory.getGraph(TestGraph.COMPLEX);
		StabilityAnalysis expectedStability = factory.getStabilityAnalysis(TestGraph.COMPLEX);
		
		GraphAnalyzer depAnalyzer = new GraphAnalyzer(graph);
		StabilityAnalysis actualStability = depAnalyzer.calculateStabilityAnalysis();
		
		assertEquals(expectedStability.getOverallStability(),
				actualStability.getOverallStability(), EPSILON);
	}

	//@Test
	public void shouldCalculateLoopOverallStability() {
			
		GraphFactory factory = new GraphFactory();
		DirectedGraph<Vertex, Edge> graph = factory.getGraph(TestGraph.LOOP);
		StabilityAnalysis expectedStability = factory.getStabilityAnalysis(TestGraph.LOOP);
		
		GraphAnalyzer depAnalyzer = new GraphAnalyzer(graph);
		StabilityAnalysis actualStability = depAnalyzer.calculateStabilityAnalysis();
		
		assertEquals(expectedStability.getOverallStability(),
				actualStability.getOverallStability(), EPSILON);
	}
	
}
