#include "definitions.h"

class BPMNUnitTask
{
	
private:
	int type; 
	int id;
	int marker;
	int marker2;
	/*
	type = :
		OPERATION for Operation;
		XOR_SPLIT for XOR Split;
		XOR_JOIN for XOR Join;
		AND_SPLIT for AND Split;
		AND_JOIN for AND Join;
		OR_SPLIT for OR Split;
		OR_JOIN for OR Join;
		*/
	float srt;
	float ec;
	float ava;
	float rel;

public:

	BPMNUnitTask(); 
	BPMNUnitTask(int typevalue, int idval, float srtvalue, float ecvalue);
	~BPMNUnitTask();

	int getType();
	int getId();
	float getSrt();
	float getEc();
	float getAva();
	float getRel();
	void setId(int v);

	void setType(int typevalue);
	void setSrt(float srtvalue);
	void setEc(float ecvalue);
	void setAva(float avavalue);
	void setRel(float relvalue);



	BPMNUnitTask **succs;
	BPMNUnitTask **preds;

	BPMNUnitTask *predLoop;
	BPMNUnitTask *leaf;

/*	In the general case, a node might have many predecessors and successors 
	In the case of operation, we have only one predecessor and one successor. 
*/
	
	void increasePredNumber();
	void increaseSuccNumber();
	void setPred(BPMNUnitTask *t);
	void setleaf(BPMNUnitTask *l);

	void removeSuccessor(BPMNUnitTask *t);
	void removePredecessor(BPMNUnitTask *t);

	void removeallSuccessors();
	void removeallPredecessors();

	void mark();
	void mark2();
	
	int isMarked();
	int isMarked2();
	
	void unmark();
	void init();
	
	void setProbability(int succi, float pi);
	void setnloop(int n);

	
	int succNumber;
	int predNumber;
	int nloop; // if this is set to more than one, then the task leads to a loop towards
	float *prbSucc; // define the probabilities for a request executed by the actual operation  to be routed 
	// towards any successor 
	
	int loop_starter;// Is the task or not a loop started?
	
};


