package it.univaq.di.choreos.coordinationprotocol.algorithm;

import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.AllowedOperation;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.Participant;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.State;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.queue.CDQueueElement;

import java.util.List;

public interface CoordinationDelegateManager {
	
	CoordinationResult isRequestAllowedFromS(AllowedOperation request);
	List<Participant> getAllCoordinationDelegates(AllowedOperation request);
	boolean isPrivilegeGranted(AllowedOperation request, Participant coordinatinoDelegateFrom, List<CDQueueElement> blockMessages);
	void updateGlobaState(AllowedOperation request);
	List<Participant> getAllAllowedComponentInTargetState(AllowedOperation request);
	void addBlock2Queue(CDQueueElement cdQueueElement);
	void removeBlockFromQueue(Participant coordinationDelegateFrom, Participant coordinationDelegateTo);
	void removeBlocksFromQueue(String coordinationdelegatefrom, String coordinationdelegateto, State oldState);
	boolean isBefore(String coordinationDelegateFrom, String coordinationDelegateTo);
	
}
