package it.univaq.di.choreos.coordinationprotocol.algorithm.model.queue;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class CDQueue {

	private List<CDQueueElement> queue;

	public CDQueue() {
		queue = new ArrayList<CDQueueElement>();

	}

	public synchronized void add(CDQueueElement element) {
		queue.add(element);

	}

	public synchronized void removeBlockFromQueue(String coordinationDelegateFrom, String coordinationDelegateTo) {
		for (Iterator<CDQueueElement> iterator = queue.iterator(); iterator.hasNext();) {
			CDQueueElement cdQueueElement = iterator.next();
			if (cdQueueElement.getCoordinationDelegateFrom().getName().equals(coordinationDelegateFrom)
					&& cdQueueElement.getCoordinationDelegateTo().getName().equals(coordinationDelegateTo)) {
				iterator.remove();
			}
		}
	}

	public synchronized void removeBlocksFromQueue(String coordinationdelegatefrom, String coordinationdelegateto, String oldState) {
		for (Iterator<CDQueueElement> iterator = queue.iterator(); iterator.hasNext();) {
			CDQueueElement cdQueueElement = iterator.next();
			if (cdQueueElement.getCoordinationDelegateFrom().getName().equals(coordinationdelegatefrom)
					&& cdQueueElement.getCoordinationDelegateTo().getName().equals(coordinationdelegateto) && cdQueueElement.getState().getName().equals(oldState)) {
				iterator.remove();
			}

		}
	}

	public synchronized List<CDQueueElement> getBlocksReceived(CDQueueElement cdQueueElement) {
		List<CDQueueElement> result = new ArrayList<CDQueueElement>();
		for (CDQueueElement element : queue) {
			if (cdQueueElement.getCoordinationDelegateTo().getName().equals(element.getCoordinationDelegateFrom().getName()) &&
				cdQueueElement.getState().getName().equals(element.getState().getName())) {
				result.add(element);
			}
		}
		
		return result;
	}

}
