package it.univaq.di.choreos.elts.strongsimulation;

import it.univaq.di.choreos.ELTS.ActivityLoop;
import it.univaq.di.choreos.ELTS.ActivityLoop2State;
import it.univaq.di.choreos.ELTS.Alternative;
import it.univaq.di.choreos.ELTS.Alternative2State;
import it.univaq.di.choreos.ELTS.FinalState;
import it.univaq.di.choreos.ELTS.Fork;
import it.univaq.di.choreos.ELTS.Fork2State;
import it.univaq.di.choreos.ELTS.InitialState;
import it.univaq.di.choreos.ELTS.InitialState2State;
import it.univaq.di.choreos.ELTS.Join;
import it.univaq.di.choreos.ELTS.Join2State;
import it.univaq.di.choreos.ELTS.LabeledState2State;
import it.univaq.di.choreos.ELTS.Operation;
import it.univaq.di.choreos.ELTS.OperationType;
import it.univaq.di.choreos.ELTS.State;
import it.univaq.di.choreos.ELTS.State2ActivityLoop;
import it.univaq.di.choreos.ELTS.State2Alternative;
import it.univaq.di.choreos.ELTS.State2FinalState;
import it.univaq.di.choreos.ELTS.State2Fork;
import it.univaq.di.choreos.ELTS.State2Join;
import it.univaq.di.choreos.ELTS.State2State;

public interface ELTSManager {
	State createState (String stateName);
	Fork createFork (String forkName);
	Join createJoin (String joinName);
	Alternative createAlternative (String alternativeName);
	ActivityLoop createActivityLoop (String activityLoopName);
	
	LabeledState2State createLabeledState2State(State source, State target, OperationType operationType, Operation operation);
	Join2State createJoin2State(Join source, State target);
	State2Fork createState2Fork(State source, Fork target);
	Fork2State createFork2State(Fork source, State target);
	State2Join createState2Join(State source, Join target);
	InitialState2State createInitialState2State(InitialState source, State target);
	State2FinalState createState2FinalState(State source, FinalState target);
	State2Alternative createState2Alternative(State source, Alternative target);
	Alternative2State createAlternative2State(Alternative source, State target);
	State2ActivityLoop createState2ActivityLoop(State source, ActivityLoop target);
	ActivityLoop2State createActivityLoop2State(ActivityLoop source, State target);
	State2State createState2State(State source, State target);
}
