package it.univaq.di.choreos.elts.strongsimulation.impl;


import it.univaq.di.choreos.ELTS.ActivityLoop;
import it.univaq.di.choreos.ELTS.Alternative;
import it.univaq.di.choreos.ELTS.EpsilonTransition;
import it.univaq.di.choreos.elts.strongsimulation.CheckCorrectness;
import it.univaq.di.choreos.elts.strongsimulation.CorrectnessException;
import it.univaq.di.choreos.elts.strongsimulation.ELTSModel;

public class CheckCorrectnessImpl implements CheckCorrectness{

	@Override
	public boolean checkExistConditionAlternative(ELTSModel modelManager)throws CorrectnessException {
		for (Alternative alternative : modelManager.getAlternatives()) {
			for (EpsilonTransition epsilonTransition : modelManager.getAllTransitionsFromAlternative(alternative)) {
				if (epsilonTransition.getCondition().trim().isEmpty() )
					throw new CorrectnessException();
			}
		}
		return true;
	}
	
	@Override
	public boolean checkExistConditionActivityLoop(ELTSModel modelManager) throws CorrectnessException {
		for (ActivityLoop activityLoop : modelManager.getActivityLoops()) {
			for (EpsilonTransition epsilonTransition : modelManager.getAllTransitionsFromActivityLoop(activityLoop)) {
				if (epsilonTransition.getCondition().trim().isEmpty() )
					throw new CorrectnessException();
			}
		}
		return true;
	}

	@Override
	public boolean checkTracksForkEndsNotMoreTransitions(ELTSModel modelManager) throws CorrectnessException {
		return true;
	}

	@Override
	public boolean checkTracksForkNotUncrossed(ELTSModel modelManager) throws CorrectnessException {
		return true;
	}

	

}
