package it.univaq.di.choreos.coordderivator;

import it.univaq.di.choreos.CLTS.ActivityLoop;
import it.univaq.di.choreos.CLTS.ActivityLoop2State;
import it.univaq.di.choreos.CLTS.Alternative2State;
import it.univaq.di.choreos.CLTS.EpsilonTransition;
import it.univaq.di.choreos.CLTS.Fork2State;
import it.univaq.di.choreos.CLTS.InitialState2State;
import it.univaq.di.choreos.CLTS.Join2State;
import it.univaq.di.choreos.CLTS.LabeledState2State;
import it.univaq.di.choreos.CLTS.LabeledTransition;
import it.univaq.di.choreos.CLTS.Model;
import it.univaq.di.choreos.CLTS.NamedElement;
import it.univaq.di.choreos.CLTS.State;
import it.univaq.di.choreos.CLTS.State2ActivityLoop;
import it.univaq.di.choreos.CLTS.State2Alternative;
import it.univaq.di.choreos.CLTS.State2FinalState;
import it.univaq.di.choreos.CLTS.State2Fork;
import it.univaq.di.choreos.CLTS.State2Join;
import it.univaq.di.choreos.CLTS.State2State;
import it.univaq.di.choreos.CLTS.Transition;

import java.util.ArrayList;
import java.util.List;


public class CltsWrapper {

	private Model model;

	public CltsWrapper(Model model) {
		this.model = model;
	}

	
	public List<LabeledTransition> getStartLabeledTransitions(){
		List<LabeledTransition> labeledTransitions = new ArrayList<LabeledTransition>();
			
		State startState = null;
		//get target State of the InitialState2State
		for (Transition transition : model.getEpsilonTransitions()) {
			if (transition instanceof InitialState2State) {
				startState = ((InitialState2State) transition).getTarget();
				break;	
			}
		}
		
		List<Transition> transitions = getNextTransitions(startState);
		//get only LabeledState2State
		for (Transition transition : transitions) {
			if (transition instanceof LabeledState2State) {
				labeledTransitions.add((LabeledState2State)transition);
			}
			//check fork
			else if (transition instanceof State2Fork) {
				// TODO
			}
			//check ActivityLoop
			else if (transition instanceof State2ActivityLoop) {
				// TODO
			}
		}
		
		return labeledTransitions;
	}

	public List<Transition> getNextTransitions(NamedElement element) {
		List<Transition> transitions = new ArrayList<Transition>();
		if (element instanceof State) {
			for (Transition transition : model.getLabeledTransitions()) {
				if (((LabeledState2State) transition).getSource().equals(element))
					transitions.add(transition);
			}
			for (Transition transition : model.getEpsilonTransitions()) {
				if (transition instanceof State2State) {
					if (((State2State) transition).getSource().equals(element))
						transitions.add(transition);
				} else if (transition instanceof State2Fork) {
					if (((State2Fork) transition).getSource().equals(element))
						transitions.add(transition);
				} else if (transition instanceof State2Join) {
					if (((State2Join) transition).getSource().equals(element))
						transitions.add(transition);
				} else if (transition instanceof State2Alternative) {
					if (((State2Alternative) transition).getSource().equals(element))
						transitions.add(transition);
				} else if (transition instanceof State2ActivityLoop) {
					if (((State2ActivityLoop) transition).getSource().equals(element))
						transitions.add(transition);
				} else if (transition instanceof State2FinalState) {
					if (((State2FinalState) transition).getSource().equals(element))
						transitions.add(transition);
				}
			}
			
		} else {
			for (Transition transition : model.getEpsilonTransitions()) {
				if (transition instanceof Fork2State) {
					if (((Fork2State) transition).getSource().equals(element))
						transitions.add(transition);
				} else if (transition instanceof Join2State) {
					if (((Join2State) transition).getSource().equals(element))
						transitions.add(transition);
				} else if (transition instanceof Alternative2State) {
					if (((Alternative2State) transition).getSource().equals(element))
						transitions.add(transition);
				} else if (transition instanceof ActivityLoop2State) {
					if (((ActivityLoop2State) transition).getSource().equals(element))
						transitions.add(transition);
				}
			}
		}
		return transitions;
	}

	public NamedElement getStateSource (Transition transition){
		if(transition instanceof State2FinalState){
			return ((State2FinalState) transition).getSource();
		}else if(transition instanceof State2State){
			return ((State2State) transition).getSource();
		}else if(transition instanceof LabeledState2State){
			return ((LabeledState2State) transition).getSource();
		}else if(transition instanceof Fork2State){
			return ((Fork2State) transition).getSource();
		}else if(transition instanceof State2Fork){
			return ((State2Fork) transition).getSource();
		}else if(transition instanceof Join2State){
			return ((Join2State) transition).getSource();
		}else if(transition instanceof State2Join){
			return ((State2Join) transition).getSource();
		}else if(transition instanceof Alternative2State){
			return ((Alternative2State) transition).getSource();
		}else if(transition instanceof State2Alternative){
			return ((State2Alternative) transition).getSource();
		}else if(transition instanceof ActivityLoop2State){
			return ((ActivityLoop2State) transition).getSource();
		}else if(transition instanceof State2ActivityLoop){
			return ((State2ActivityLoop) transition).getSource();
		}
		return null;
			
	}
	
	public NamedElement getStateTarget (Transition transition){
		if(transition instanceof State2FinalState){
			return ((State2FinalState) transition).getTarget();
		}else if(transition instanceof State2State){
			return ((State2State) transition).getTarget();
		}else if(transition instanceof LabeledState2State){
			return ((LabeledState2State) transition).getTarget();
		}else if(transition instanceof Fork2State){
			return ((Fork2State) transition).getTarget();
		}else if(transition instanceof State2Fork){
			return ((State2Fork) transition).getTarget();
		}else if(transition instanceof Join2State){
			return ((Join2State) transition).getTarget();
		}else if(transition instanceof State2Join){
			return ((State2Join) transition).getTarget();
		}else if(transition instanceof Alternative2State){
			return ((Alternative2State) transition).getTarget();
		}else if(transition instanceof State2Alternative){
			return ((State2Alternative) transition).getTarget();
		}else if(transition instanceof ActivityLoop2State){
			return ((ActivityLoop2State) transition).getTarget();
		}else if(transition instanceof State2ActivityLoop){
			return ((State2ActivityLoop) transition).getTarget();
		}
		return null;
			
	}

	public String getCoordName (Transition transition){
		if (transition instanceof LabeledTransition){
			String sourceParticipantName=((LabeledTransition)transition).getInitiatingParticipant().getName();
			String targetParticipantName=((LabeledTransition)transition).getParticipant().getName();
			return "CD-" +sourceParticipantName+"-"+targetParticipantName;
		}
		return null;
	}

	public Transition getTransitionLoopIn(ActivityLoop activityLoop){
		for (EpsilonTransition epsilonTransition : model.getEpsilonTransitions()) {
			if (epsilonTransition instanceof ActivityLoop2State && ((((ActivityLoop2State)epsilonTransition).getCondition()!=null && !((ActivityLoop2State)epsilonTransition).getCondition().isEmpty()) || ((ActivityLoop2State)epsilonTransition).getCardinality()>0)){
				 if(((ActivityLoop2State) epsilonTransition).getSource().equals(activityLoop)){
					 return epsilonTransition; 
				 }
			}
		}	
		return null;
	}

	public Transition getTransitionLoopOut(ActivityLoop activityLoop){
		for (EpsilonTransition epsilonTransition : model.getEpsilonTransitions()) {
			if (epsilonTransition instanceof ActivityLoop2State && ((((ActivityLoop2State)epsilonTransition).getCondition()==null || ((ActivityLoop2State)epsilonTransition).getCondition().isEmpty()) && ((ActivityLoop2State)epsilonTransition).getCardinality()==0)){
				 if(((ActivityLoop2State) epsilonTransition).getSource().equals(activityLoop)){
					 return epsilonTransition; 
				 }
			}
		}	
		return null;
	}

	public List<NamedElement> getStateBoundaryJoin(NamedElement join){
		List<NamedElement> boundaries = new ArrayList<NamedElement>();
		for (EpsilonTransition epsilonTransition : model.getEpsilonTransitions()) {
			if (epsilonTransition instanceof State2Join){
				if (((State2Join) epsilonTransition).getTarget().getName().equals(join.getName()))
					boundaries.add(((State2Join) epsilonTransition).getSource());
			}
			
		}
		return boundaries;
	}

}
