package it.univaq.di.choreos.coordderivator;

import it.univaq.di.choreos.CLTS.Model;
import it.univaq.di.choreos.CLTS.impl.CLTSPackageImpl;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.Coord;

import java.io.File;
import java.io.IOException;
import java.util.Calendar;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;

public class CoordDerivatorExpected {
	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		CLTSPackageImpl.init();

		String parentPath = "TestInput" + File.separatorChar + "Test_14" + File.separatorChar;
		String firstFileModel = parentPath + "clts" + File.separatorChar + "test_14.clts";
		URI firstFileURIModel = URI.createFileURI(firstFileModel);

		// create resource from the Models
		Resource resourceFirstModel = new XMIResourceFactoryImpl().createResource(firstFileURIModel);

		resourceFirstModel.load(null);

		Model firstModel = (Model) resourceFirstModel.getContents().get(0);

		Calendar c1 = Calendar.getInstance();

		// CODE HERE
		CoordDerivator cd = new CoordDerivator(firstModel);
		saveCoordsModel(parentPath+"coord"+File.separatorChar, cd.getCoords());
		
		// END CODE HERE
		Calendar c2 = Calendar.getInstance();

		// Calculates the difference in milliseconds.
		long millisDiff = c2.getTimeInMillis() - c1.getTimeInMillis();

		// Calculates days/hours/minutes/seconds.
		int seconds = (int) (millisDiff / 1000 % 60);
		int minutes = (int) (millisDiff / 60000 % 60);
		int hours = (int) (millisDiff / 3600000 % 24);
		int days = (int) (millisDiff / 86400000);

		System.out.println("Tempo Computazione");
		System.out.print(days + " days, ");
		System.out.print(hours + " hours, ");
		System.out.print(minutes + " minutes, ");
		System.out.println(seconds + " seconds");
		System.out.println(millisDiff + " milli seconds");

	}
	

	private static void saveCoordsModel(String folderDestination, List<Coord> coordsModel) {
		File fileFolderDestination = new File(folderDestination);
		if (fileFolderDestination.isDirectory()) {
			for (Coord coord : coordsModel) {
				saveModel(folderDestination + coord.getName() + ".xmi", coord);
			}
		}
	}
	
	private static boolean saveModel(String fullPathDestinationModel, Coord coord) {
		if (coord == null) {
			return false;
		}
			
		// create resource from the Model
		URI fileUriTempModelNormalized = URI.createFileURI(fullPathDestinationModel);
		Resource resourceCoord = new XMIResourceFactoryImpl().createResource(fileUriTempModelNormalized);
		// add model in model resourceModel
		resourceCoord.getContents().add(coord);
		try {
			// save new CLTS model
			resourceCoord.save(Collections.EMPTY_MAP);
		} catch (IOException e) {
			e.printStackTrace();
			return false;
		}

		return true;

	}
}

