package it.iwbank.trading;

import it.univaq.di.choreos.stockconfirm.client.StockConfirm;
import it.univaq.di.choreos.stockconfirm.client.StockConfirm_Service;

import java.net.MalformedURLException;
import java.net.URL;

import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.xml.namespace.QName;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@WebService( serviceName="Stocktrade3", targetNamespace="http://trading.iwbank.it", portName="Stocktrade3Port" )
public class Stocktrade3 {
	private final static URL STOCKCONFIRM_WSDL_LOCATION;
	
	final Logger logger = LoggerFactory.getLogger(Stocktrade3.class);

    static {
        URL url = null;
        try {
            URL baseUrl;
            baseUrl = it.univaq.di.choreos.stockconfirm.client.StockConfirm_Service.class.getResource(".");
            url = new URL(baseUrl, "http://localhost:12080/iwbank-cd/stockconfirmiwbank?wsdl");
        } catch (MalformedURLException e) {
            e.printStackTrace();
        }
        STOCKCONFIRM_WSDL_LOCATION = url;
    }
    
    @WebMethod( operationName="buy3" )
	@Oneway
	public void buy3( @WebParam( name="orderNumber" ) String orderNumber, @WebParam( name="stockSymbol" ) String stockSymbol, @WebParam( name="quantity" ) int quantity ) {		

		logger.debug("begin buy3");
		logger.debug("begin invoke IWBank->orderconfirm");
		StockConfirm_Service stockConfirmService = new StockConfirm_Service(STOCKCONFIRM_WSDL_LOCATION, new QName("http://choreos.di.univaq.it", "StockConfirm"));
		StockConfirm stockConfirmPort = stockConfirmService.getStockConfirmPort();
		stockConfirmPort.orderconfirm(orderNumber, quantity);
		logger.debug("end invoke IWBank->orderconfirm");
		logger.debug("end buy3");
	}
}