package it.univaq.di.choreos.synthesis.cdgenerator.impl.easyesb;

import it.univaq.di.choreos.synthesis.datamodel.CD;

import java.io.File;
import java.io.IOException;

import org.apache.commons.io.FileUtils;
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

public class CDServiceTest {
	private static final String EXPECTED_TEST1="" +
			"<?xml version=\"1.0\" encoding=\"UTF-8\"?>" +
			"<Configuration xmlns=\"http://ebmwebsourcing.com/cli/schema\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://ebmwebsourcing.com/cli/schema conf-schema.xsd\">" +
			"	<Service url=\"http://localhost:8180/services/adminExternalEndpoint\">" +
			"		<Action>" +
			"			<Deploy>" +
			"				<MainResource>../../CD-AIR-SGM.xmi</MainResource>" +
			"				<Resource>../../CD-AIR-SGM.wsdl</Resource>" +
			"				<Resource>../../CD-AIR-SGM.properties</Resource>" +
			"			</Deploy>" +
			"		</Action>" +
			"		<Action>" +
			"			<Expose>" +
			"				<ServiceNamespace>http://scn2.wp6.thalesgroup.choreos.ow2.org/</ServiceNamespace>" +
			"				<ServiceName>StandAndGateManagementImplService</ServiceName>" +
			"				<EndpointName>CD-AIR-SGM</EndpointName>" +
			"			</Expose>" +
			"		</Action>" +
			"	</Service>" +
			"</Configuration>";
	
	private CD cd;
	private CDService service;
	private String resourcesTest;
	
	@Before
	public void setUp() throws IOException {
		cd =null;
		service=null;
		resourcesTest = "." + File.separator + "src" + File.separator + "test" + File.separator + "resources" + File.separator + "";
	}

	@Test
	public void createConfigTest1() throws IOException {
	
		String wsdl = FileUtils.readFileToString(new File(resourcesTest + "sgm.wsdl" ));
		cd = new CD("wp6", "CD-AIR-SGM", wsdl, "");
		service = new CDService(cd);
		String result = service.getConfigContent();
		Assert.assertEquals(CDServiceUtility.format(EXPECTED_TEST1), CDServiceUtility.format(result));

		
	}

	@After
	public void tearDown() {
	}
	
	
	
}
