package it.univaq.di.choreos.synthesis.cdgenerator.impl.easyesb;

import it.univaq.di.choreos.synthesis.cdgenerator.CDGeneratorException;
import it.univaq.di.choreos.synthesis.cdgenerator.utility.CDGeneratorUtility;
import it.univaq.di.choreos.synthesis.datamodel.CD;

import java.io.File;
import java.io.IOException;

import org.apache.commons.io.FileUtils;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class EasyESBCDGeneratorTest {
	private static final String TARGZ_SUFFIX = ".tar.gz";

	private EasyESBCDGenerator easyESBCDGenerator;
	private String outputDir = "." + File.separator + "output";
	private String cdName = "CD-AIR-SGM";
	private String cdfileName;
	private String resourcesTest;
	

	private CD cdData;
	private CDService cdService;

	@Before
	public void setUp() throws IOException {

		easyESBCDGenerator = new EasyESBCDGenerator();

		String baseCDDir = CDGeneratorUtility.getRandomDir();
		String cdOutputDir = outputDir + File.separator + baseCDDir;
		cdfileName = cdOutputDir + File.separator + cdName + TARGZ_SUFFIX;
		FileUtils.forceMkdir(new File(cdOutputDir));

		resourcesTest = "." + File.separator + "src" + File.separator + "test" + File.separator + "resources" + File.separator + "";
		cdData = null;
		cdService = null;

	}

	@Test
	public void generateTest1() throws IOException, CDGeneratorException {

		String wsdl = FileUtils.readFileToString(new File(resourcesTest + "sgm.wsdl"));
		cdData = new CD("wp6", cdName, wsdl, "");
		cdService = new CDService(cdData);
		easyESBCDGenerator.generate(cdService, cdfileName);

	}

	@After
	public void tearDown() {
	}
}
