package it.univaq.di.choreos.synthesis.cdgenerator.wp6;

import it.univaq.di.choreos.synthesis.cdgenerator.CDGenerator;
import it.univaq.di.choreos.synthesis.cdgenerator.CDGeneratorException;
import it.univaq.di.choreos.synthesis.cdgenerator.rest.client.CDGeneratorClient;
import it.univaq.di.choreos.synthesis.datamodel.CD;

import java.io.File;
import java.io.IOException;

import org.apache.commons.io.FileUtils;

public class GenerateCD {
	private static final String resourceCoordName ="coordmodel";

	private static final String[][] resourceName= 
								   {{"airport", "CD-AIR-ABC.xmi", "airportbuscompany"+File.separator+"AirportBusCompany.wsdl"},
									{"airport", "CD-AIR-ADAA.xmi", "airportdisplayactuatorsaggregator"+File.separator+"AirportDisplayActuatorsAggregator.wsdl"},
									{"airport", "CD-AIR-AISA.xmi", "airportinfraredsensorsaggregator"+File.separator+"AirportInfraredSensorsAggregator.wsdl"},
									{"airport", "CD-AIR-ANSA.xmi", "airportnoisesensorsaggregator"+File.separator+"AirportNoiseSensorsAggregator.wsdl"},
									{"airport", "CD-AIR-AP.xmi", "bookableamenity"+File.separator+"BookableAmenity.wsdl"},
									{"airport", "CD-AIR-APSA.xmi", "airportpressuresensorsaggregator"+File.separator+"AirportPressureSensorsAggregator.wsdl"},
									{"airport", "CD-AIR-ASAA.xmi", "airportspeakeractuatorsaggregator"+File.separator+"AirportSpeakerActuatorsAggregator.wsdl"},
									{"airport", "CD-AIR-ASIAA.xmi", "airportsignactuatorsaggregator"+File.separator+"AirportSignActuatorsAggregator.wsdl"},
									{"airport", "CD-AIR-LHC.xmi", "luggagehandlingcompany"+File.separator+"LuggageHandlingCompany.wsdl"},
									{"airport", "CD-AIR-MIDDAA.xmi", "middisplayactuatorsaggregator"+File.separator+"MIDDisplayActuatorsAggregator.wsdl"},
									{"airport", "CD-AIR-MIDLSA.xmi", "midlocationsensorsaggregator"+File.separator+"MIDLocationSensorsAggregator.wsdl"},
									{"airport", "CD-AIR-MIDMSA.xmi", "midmicrophonesensorsaggregator"+File.separator+"MIDMicrophoneSensorsAggregator.wsdl"},
									{"airport", "CD-AIR-SC.xmi", "securitycompany"+File.separator+"SecurityCompany.wsdl"},
									{"airport", "CD-AIR-SGM.xmi", "standandgatemanagement"+File.separator+"StandAndGateManagement.wsdl"},
									{"airportbuscompany", "CD-ABC-AIR.xmi", "airport"+File.separator+"Airport.wsdl"},
									{"airportinfraredsensorsaggregator", "CD-AISA-AIR.xmi", "airport"+File.separator+"Airport.wsdl"},
									{"airtrafficcontrol", "CD-ATC-AIR.xmi", "airport"+File.separator+"Airport.wsdl"},
									{"luggagehandlingcompany", "CD-LHC-AIR.xmi", "airport"+File.separator+"Airport.wsdl"},
									{"securitycompany", "CD-SC-AIR.xmi", "airport"+File.separator+"Airport.wsdl"},
									{"standandgatemanagement", "CD-SGM-AIR.xmi", "airport"+File.separator+"Airport.wsdl"}};
	 private static final String host = "http://localhost:10002/cdgenerator";
     private static CDGenerator cdGenerator;
     private static final String resourcesInput = "." + File.separator + "src" + File.separator + "test" + File.separator + "resources" + File.separator + "wp6"+File.separator+"input" + File.separator + "";
	
     public static void main(String[] args) {
    	 cdGenerator = new CDGeneratorClient(host);
  		for(int i = 0; i < resourceName.length; i++){
  			try {
  				String cd_name=resourceName[i][1].replace(".xmi", "");
  				generate(resourceName[i][0],cd_name,resourceName[i][1],resourceName[i][2]);
  			} catch (IOException e) {
  				// TODO Auto-generated catch block
  				e.printStackTrace();
  			} catch (CDGeneratorException e) {
  				// TODO Auto-generated catch block
  				e.printStackTrace();
  			}
  		}
	}
     
	private static void generate(String serviceName, String cd_name ,String coordName, String wsdlURI) throws IOException, CDGeneratorException{
		String wsdl = FileUtils.readFileToString(new File(resourcesInput + wsdlURI ));
		String coord = FileUtils.readFileToString(new File(resourcesInput+serviceName+File.separator +resourceCoordName+File.separator+ coordName ));
		CD cd = new CD("wp6", cd_name, wsdl, coord);
		cd.setParentFolderName(serviceName);
		String result = cdGenerator.generate(cd);
        System.out.println("result= " + result);
		
	}
}
