package it.univaq.di.choreos.synthesis.m2mtransformator.rest.client;

import it.univaq.di.choreos.synthesis.datamodel.AbstractParticipant;
import it.univaq.di.choreos.synthesis.datamodel.CLTSModel;
import it.univaq.di.choreos.synthesis.datamodel.ChoreographyBPMNSpecification;
import it.univaq.di.choreos.synthesis.datamodel.Participant;
import it.univaq.di.choreos.synthesis.m2mtransformator.M2MTransformator;
import it.univaq.di.choreos.synthesis.m2mtransformator.M2MTransformatorException;
import it.univaq.di.choreos.synthesis.m2mtransformator.rest.Abstract2ConcreteCLTSModel;
import it.univaq.di.choreos.synthesis.m2mtransformator.rest.Participants;

import java.util.List;

import javax.ws.rs.WebApplicationException;

import org.apache.cxf.jaxrs.client.WebClient;
import org.apache.cxf.transport.http.HTTPConduit;
import org.apache.cxf.transports.http.configuration.HTTPClientPolicy;

public class M2MTransformatorClient implements M2MTransformator {
	private String host;

	public M2MTransformatorClient(String host) {
		this.host = host;
	}

	private WebClient setupClient() {

		WebClient client = WebClient.create(host);

		// remove time out
		// not proud of it!
		HTTPConduit http = (HTTPConduit) WebClient.getConfig(client).getConduit();
		HTTPClientPolicy httpClientPolicy = new HTTPClientPolicy();
		httpClientPolicy.setConnectionTimeout(0);// indefined
		httpClientPolicy.setReceiveTimeout(0);// indefined
		http.setClient(httpClientPolicy);

		return client;
	}

	public CLTSModel bpmn2clts(ChoreographyBPMNSpecification bpmnchoreographyspecification) throws M2MTransformatorException {
		WebClient client = setupClient();
		client.path("bpmn2clts");

		try {
			return client.post(bpmnchoreographyspecification, CLTSModel.class);
		} catch (WebApplicationException e) {
			throw new M2MTransformatorException();
		}
	}

	@Override
	public List<Participant> clts2coords(CLTSModel cltsModel) throws M2MTransformatorException {
		WebClient client = setupClient();
		client.path("clts2coords");

		try {
			Participants participants = client.post(cltsModel, Participants.class);
			return participants.getParticipants();
		} catch (WebApplicationException e) {
			throw new M2MTransformatorException();
		}
	}

	@Override
	public CLTSModel abstract2ConcreteCLTSModel(CLTSModel cltsModel, List<AbstractParticipant> participants) throws M2MTransformatorException {
		WebClient client = setupClient();
		client.path("abstract2ConcreteCLTSModel");

		try {
			Abstract2ConcreteCLTSModel abstract2ConcreteCLTSModel = new Abstract2ConcreteCLTSModel(cltsModel, participants); 
			return client.post(abstract2ConcreteCLTSModel, CLTSModel.class);
		} catch (WebApplicationException e) {
			throw new M2MTransformatorException();
		}
	}

}
