package it.univaq.di.choreos.synthesis.m2mtransformator;

import it.univaq.di.choreos.synthesis.datamodel.CLTSModel;
import it.univaq.di.choreos.synthesis.datamodel.Participant;
import it.univaq.di.choreos.synthesis.m2mtransformator.impl.M2MTransformatorImpl;

import java.io.File;
import java.io.IOException;
import java.util.List;

import junit.framework.Assert;

import org.apache.commons.io.FileUtils;
import org.junit.Before;
import org.junit.Test;


public class Clts2CoordsTest {
	private String resourcesRoot="." + File.separator + "src" + File.separator + "test" + File.separator + "resources";
	private M2MTransformator m2mTransformator;
	private CLTSModel cltsModel;
	@Before
	public void setUp() {
		m2mTransformator = new M2MTransformatorImpl();
		cltsModel = new CLTSModel();
	}
	
	@Test
	public void test01() throws IOException, M2MTransformatorException {
		String cltsFilePath = resourcesRoot + File.separator + "clts2coordstest" + File.separator +"test_01"+ File.separator + "test_01.clts";
		cltsModel.setCltsModel(FileUtils.readFileToString(new File (cltsFilePath)));
		List<Participant> participants = m2mTransformator.clts2coords(cltsModel);
		Assert.assertEquals(3, participants.size());
	}
	
	@Test
	public void test02() throws IOException, M2MTransformatorException {
		String cltsFilePath = resourcesRoot + File.separator + "clts2coordstest" + File.separator +"test_02"+ File.separator + "test_02.clts";
		cltsModel.setCltsModel(FileUtils.readFileToString(new File (cltsFilePath)));
		List<Participant> participants = m2mTransformator.clts2coords(cltsModel);
		Assert.assertEquals(16, participants.size());
	}


}
