package it.univaq.di.choreos.synthesis.servicediscovery.rest.client;

import it.univaq.di.choreos.synthesis.datamodel.Service;
import it.univaq.di.choreos.synthesis.datamodel.ServiceDiscoveryInput;
import it.univaq.di.choreos.synthesis.servicediscovery.ServiceDiscovery;
import it.univaq.di.choreos.synthesis.servicediscovery.ServiceDiscoveryException;
import it.univaq.di.choreos.synthesis.servicediscovery.rest.ResponseDiscoverServices;

import java.util.List;

import javax.ws.rs.WebApplicationException;

import org.apache.cxf.jaxrs.client.WebClient;
import org.apache.cxf.transport.http.HTTPConduit;
import org.apache.cxf.transports.http.configuration.HTTPClientPolicy;

public class ServiceDiscoveryClient implements ServiceDiscovery {
	private String host;

	public ServiceDiscoveryClient(String host) {
		this.host = host;
	}

	private WebClient setupClient() {

		WebClient client = WebClient.create(host);

		// remove time out
		// not proud of it!
		HTTPConduit http = (HTTPConduit) WebClient.getConfig(client).getConduit();
		HTTPClientPolicy httpClientPolicy = new HTTPClientPolicy();
		httpClientPolicy.setConnectionTimeout(0);// indefined
		httpClientPolicy.setReceiveTimeout(0);// indefined
		http.setClient(httpClientPolicy);

		return client;
	}

	public List<Service> discoverServices(ServiceDiscoveryInput serviceDiscoveryInput) throws ServiceDiscoveryException {
		WebClient client = setupClient();
		client.path("discoverServices");

		try {
			ResponseDiscoverServices result = client.post(serviceDiscoveryInput, ResponseDiscoverServices.class);
			return result.getServices();

		} catch (WebApplicationException e) {
			throw new ServiceDiscoveryException();
		}
	}

}
