package it.univaq.di.choreos.synthesis.synthesisprocessor.dummies.wp6;

import it.univaq.di.choreos.synthesis.datamodel.AbstractParticipant;
import it.univaq.di.choreos.synthesis.datamodel.CLTSModel;
import it.univaq.di.choreos.synthesis.datamodel.ChoreographyBPMNSpecification;
import it.univaq.di.choreos.synthesis.datamodel.Participant;
import it.univaq.di.choreos.synthesis.m2mtransformator.M2MTransformator;
import it.univaq.di.choreos.synthesis.m2mtransformator.M2MTransformatorException;
import it.univaq.di.choreos.synthesis.m2mtransformator.impl.M2MTransformatorImpl;

import java.io.File;
import java.io.IOException;
import java.util.List;

import org.apache.commons.io.FileUtils;

public class WP6M2MTransformator implements M2MTransformator {
	private static final String CLTSWP6_FILENAME = "." + File.separator + "src" + File.separator + "test" + File.separator + "resources" + File.separator + "wp6" + File.separator + "clts-input"+ File.separator + "wp6.clts";
	private M2MTransformator m2mTransformator;

	public WP6M2MTransformator() {
		m2mTransformator = new M2MTransformatorImpl();
	}

	public CLTSModel bpmn2clts(ChoreographyBPMNSpecification bpmnchoreographyspecification) throws M2MTransformatorException {
		CLTSModel cltsModel = new CLTSModel();
		try {
			cltsModel.setCltsModel(FileUtils.readFileToString(new File(CLTSWP6_FILENAME)));
		} catch (IOException e) {
			e.printStackTrace();
		}
		return cltsModel;
	}

	@Override
	public List<Participant> clts2coords(CLTSModel cltsModel) throws M2MTransformatorException {
		return m2mTransformator.clts2coords(cltsModel);
	}
	

	@Override
	public CLTSModel abstract2ConcreteCLTSModel(CLTSModel cltsModel, List<AbstractParticipant> participants) throws M2MTransformatorException {
		return cltsModel;
	}


}
