package it.univaq.di.choreos.synthesis.synthesisprocessor.dummies.wp7;

import org.ow2.choreos.chors.ChoreographyDeployer;
import org.ow2.choreos.chors.ChoreographyNotFoundException;
import org.ow2.choreos.chors.EnactmentException;
import org.ow2.choreos.chors.datamodel.Choreography;
import org.ow2.choreos.chors.datamodel.ChoreographySpec;

public class WP7ChoreographyDeployer implements ChoreographyDeployer {
	private String chorId;
	private ChoreographySpec chorSpec;

	public WP7ChoreographyDeployer(String chorId) {
		this.chorId = chorId;
	}

	@Override
	public String createChoreography(ChoreographySpec chorSpec) {
		this.chorSpec = chorSpec;
		return chorId;
	}

	@Override
	public Choreography getChoreography(String chorId) throws ChoreographyNotFoundException {
		Choreography choreography = new Choreography();
		choreography.setId(chorId);
		choreography.setChoreographySpec(chorSpec);
		return choreography;
	}

	@Override
	public Choreography enactChoreography(String chorId) throws EnactmentException, ChoreographyNotFoundException {
		Choreography choreography = new Choreography();
		choreography.setId(chorId);
		choreography.setChoreographySpec(chorSpec);
		return choreography;
	}

	@Override
	public void updateChoreography(String chorId, ChoreographySpec spec) throws EnactmentException, ChoreographyNotFoundException {
		// DO nothing

	}

}
