package it.univaq.di.choreos.synthesis.synthesisprocessor.dummies.wp7;

import it.univaq.di.choreos.synthesis.datamodel.Service;
import it.univaq.di.choreos.synthesis.datamodel.ServiceDiscoveryInput;
import it.univaq.di.choreos.synthesis.servicediscovery.ServiceDiscovery;
import it.univaq.di.choreos.synthesis.servicediscovery.ServiceDiscoveryException;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.io.FileUtils;

public class WP7ServiceDiscovery implements ServiceDiscovery {
	
	private static final String[][] resourceService= 
		   {{"basiccomunicationdevice", "basiccomunicationdevice"+File.separator+"basiccommunicationdevice.wsdl"},
			{"client", "client"+File.separator+"client.wsdl"},
			{"instoretotem", "instoretotem"+File.separator+"instoretotem.wsdl"},
			{"marketingapplication", "marketingapplication"+File.separator+"marketingapplication.wsdl"},
			{"marketingmanager", "marketingmanager"+File.separator+"marketingmanager.wsdl"},
			{"selfcheckoutmachine", "selfcheckoutmachine"+File.separator+"selfcheckoutmachine.wsdl"},
			{"shopentrance", "shopentrance"+File.separator+"shopentrance.wsdl"},
			{"shoppingassistants", "shoppingassistants"+File.separator+"shoppingassistantapp.wsdl"},
			{"smartcart", "smartcart"+File.separator+"smartcart.wsdl"}			
			};
	
	private Map<String, List<Service>> services;
	private String resourcesWsdl = "." + File.separator + "src" + File.separator + "test" + File.separator + "resources" + File.separator + "wp7"+ File.separator + "wsdl-input"+ File.separator;
	
	public WP7ServiceDiscovery() {
		services = new HashMap<String, List<Service>>();
		for (int i =0; i<resourceService.length; i++){
			List<Service> servicesDiscovery = new ArrayList<Service>();
			Service service = new Service();
			File wsdlFile = new File(resourcesWsdl+resourceService[i][1]);
			try {
				service.setWsdl(FileUtils.readFileToString(wsdlFile));
				service.setServiceURI(resourceService[i][0]);
				servicesDiscovery.add(service);
				services.put(resourceService[i][0], servicesDiscovery);
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public List<Service> discoverServices(ServiceDiscoveryInput serviceDiscoveryInput) throws ServiceDiscoveryException {
		return services.get(serviceDiscoveryInput.getParticipant());
	}

}
